<template>
  <div class="v-container">
    <div class="v-row">
      <div class="v-col col-12">
<!--        рисуем таблицу со списком сотрудников  -->
        <v-data-table
            :headers="headers"
            :items="employees"
            sort-by="calories"
            class="elevation-1"
        >
<!--       рисуем верхнюю строку с инструментами   -->
          <template v-slot:top>
            <v-toolbar flat>
              <v-toolbar-title>Список сотрудников</v-toolbar-title>
              <v-spacer></v-spacer>
<!--             вставляем копку добавления сотрудника-->
              <v-btn
                  color="primary"
                  dark
                  class="mb-2"
                  :to="`/employee/create`"
              >
                Добавить сотрудника
              </v-btn>
<!--              встраиваем диалоговое окно  -->
              <DeleteItemModal
                  v-model="dialogDelete"
                  :item="employee"
                  @delItem="onDeleteItem"
              />
            </v-toolbar>
          </template>
<!--        обрабатываем поле с количеством друзей, т.к. надо вывести их количество  -->
          <template v-slot:item.friends="{ item }">
            {{ item.friends.length }}
          </template>
<!--        обрабатываем столбец с действиями над пользователем -->
          <template v-slot:item.actions="{ item }">
            <v-icon
                v-for="action in actions"
                :key="action.type+item.eMail"
                class="mr-4"
                @click="actionItem(item, action.type)"
            >
              {{ action.icon }}
            </v-icon>
          </template>
          <template v-slot:no-data>
            <v-btn
                color="primary"
                @click="initialize"
            >
              Reset
            </v-btn>
          </template>
        </v-data-table>
      </div>
    </div>
  </div>
</template>

<script>
import {
  mdiEye,
  mdiPencil,
  mdiDelete,
} from '@mdi/js'
import DeleteItemModal from "../components/modals/DeleteItemModal";
import {mapMutations, mapState} from "vuex";

export default {
  name: 'Employees',
  components: {DeleteItemModal},
  data: () => ({
    headers: [
      {
        text: "Имя",
        align: 'start',
        sortable: true,
        value: 'name',
        displayHandler: null,
      },
      {
        text: "Фамилия",
        align: 'start',
        sortable: true,
        value: 'sName',
        displayHandler: null,
      },
      {
        text: "Отчество",
        align: 'start',
        sortable: false,
        value: 'mName',
        displayHandler: null,
      },
      {
        text: "e-mail",
        align: 'start',
        sortable: false,
        value: 'eMail',
        displayHandler: null,
      },
      {
        text: "Количество друзей",
        align: 'start',
        sortable: false,
        value: 'friends',
      },
      {
        text: "",
        align: 'start',
        sortable: false,
        value: 'actions',
      },
    ], // заголовки таблицы
    actions: [
      {
        text: "Просмотреть данные сотрудника",
        icon: mdiEye,
        type: "view",
      },
      {
        text: "Отредактировать данные сотрудника",
        icon: mdiPencil,
        type: "edit",
      },
      {
        text: "Удалить сотрудника",
        icon: mdiDelete,
        type: "delete",
      },
    ], // действия над сотрудниками
    dialogDelete: false,  // диалоговое окно для удаления записи
  }),
  computed: {
    ...mapState(['employees', 'employee']),
  },
  methods: {
    ...mapMutations(['deleteItem', 'fillEmployee']),
    actionItem(item, action) { // выбираем какое действие совершить над сотрудником
      this.fillEmployee(item)
      switch (action) {
        case "create":
        case "view":
        case "edit":
          this.$router.push({name: "Employee", params: {method: action}, query: {id: item.id}}) // переходим на страницу с данными сотрудника
          break
        case "delete":
          this.dialogDelete = true // открываем диалоговое окно с подтверждением удаления
      }
    },

    onDeleteItem() {
      this.deleteItem() // вызываем метод удаления записи после подтверждения в диалоговом окне
      this.dialogDelete = false // закрываем диалоговое окно
    },
  },
}
</script>
